/*  vectors.S

    exception table, VSR lookup table, and VSR traps
    fast interrupt service routine

    -----

    Copyright (c) Freescale Semiconductor, Inc., 2004

    This file is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This file is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this file; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place, Suite 330
    Boston, MA  02111-1307  USA
*/

/*
$Id: $
*/

        .code   32
        .section ".vectors","ax"
        .global __vectors
__vectors:

        ldr      pc,._reset             /* 0x0000 */
        ldr      pc,.UND_trap           /* 0x0004 */
        ldr      pc,.SWI_trap           /* 0x0008 */
        ldr      pc,.PAB_trap           /* 0x000C */
        ldr      pc,.DAB_trap           /* 0x0010 */
        .word    0x0000                 /* unused */
        ldr      pc,.vsr_IRQ            /* 0x0018 */
                                                                      
                                        /* 0x001C FIQ service routine */
        ldr      r10, .__PIT_base       /* r10 := PIT base address    */
        mov      r11, #0x4              /* TIF2 is bit 2              */
        str      r11, [r10, #0x100]     /* clear the TIF2 flag        */

        add      r8, r8, #0x01          /* increment r8               */
        ldr      r10, .__portF_base     /* r10 := port F base address */
        ands     r8, r8, #0x0F          /* r8 := (r8 modulo 16)       */

        moveq    r11, #0x00             /* set correct bit state      */
        movne    r11, #0x01        
        strb     r11, [r10, #0x37]      /* write port F PINDATA[15]   */

        subs     pc, lr, #4             /* return from FIQ            */

        .global __VSR_table
__VSR_table:

._reset:         .word        _reset
.UND_trap:       .word        UND_trap
.SWI_trap:       .word        SWI_trap
.PAB_trap:       .word        PAB_trap
.DAB_trap:       .word        DAB_trap
.vsr_IRQ:        .word        vsr_IRQ
.FIQ_trap:       .word        FIQ_trap

        .global __vector_service
__vector_service:

UND_trap:         b UND_trap
SWI_trap:         b SWI_trap
PAB_trap:         b PAB_trap
DAB_trap:         b DAB_trap
IRQ_trap:         b IRQ_trap
FIQ_trap:         b FIQ_trap

.__portF_base:    .word       0xFC0E8140
.__PIT_base:      .word       0xFC08C000
