/* _memcpy.c 

   replaces the standard library function

   The C runtime libraries are optimized, making single-stepping 
   through the C code difficult or impossible (assembler is still OK).
   This is a private, unoptimized version to allow debugging at the
   C source level.

   -----

   Copyright (c) Freescale Semiconductor, Inc., 2004

   This file is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This file is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this file; if not, write to:

   Free Software Foundation, Inc.
   59 Temple Place, Suite 330
   Boston, MA  02111-1307  USA

*/

/*
$Id: $
*/

unsigned char * _memcpy (unsigned char* dest, const unsigned char* src, int size);

unsigned char *
_memcpy (unsigned char* dest, const unsigned char* src, int size)
{
    unsigned char* __d = dest;
    const unsigned char* __s = src;

    while(size--)
        *__d++ = *__s++;

    return dest;
}
