/* jumptab.c

   jump table initialization

   -----

   Copyright (c) Freescale Semiconductor, Inc., 2004

   This file is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This file is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this file; if not, write to:

   Free Software Foundation, Inc.
   59 Temple Place, Suite 330
   Boston, MA  02111-1307  USA

*/

/*
$Id: $
*/

/* the VSR in crt0.S requires the jump table to be at 0x40000000.
   If you don't put it there, then you must rewrite the vsr_IRQ 
   function so it can find the table. */

#include "isr.h"    /* prototypes for isr stub functions */

void (* jumptab[64])(void) =
{
  &isr_eDMA0,            /*  0 0x000 */
  &isr_eDMA1,            /*  1 0x004 */
  &isr_eDMA2,            /*  2 0x008 */
  &isr_eDMA3,            /*  3 0x00C */
  &isr_eDMA4,            /*  4 0x010 */
  &isr_eDMA5,            /*  5 0x014 */
  &isr_eDMA6,            /*  6 0x018 */
  &isr_eDMA7,            /*  7 0x01C */
  &isr_eDMA8,            /*  8 0x020 */
  &isr_eDMA9,            /*  9 0x024 */
  &isr_eDMA10,           /* 10 0x028 */
  &isr_eDMA11,           /* 11 0x02C */
  &isr_eDMA12,           /* 12 0x030 */
  &isr_eDMA13,           /* 13 0x034 */
  &isr_eDMA14,           /* 14 0x038 */
  &isr_eDMA15,           /* 15 0x03C */
  &isr_eDMA_Error,       /* 16 0x040 */
  &isr_MCM_SWT,          /* 17 0x044 */
  &isr_CRG,              /* 18 0x048 */
  &isr_PIT1,             /* 19 0x04C */
  &isr_PIT2,             /* 20 0x050 */
  &isr_PIT3,             /* 21 0x054 */
  &isr_PIT4_RTI,         /* 22 0x058 */
  &isr_VREG,             /* 23 0x05C */
  &isr_CAN_A_MB,         /* 24 0x060 */
  &isr_CAN_A_MB14,       /* 25 0x064 */
  &isr_CAN_A_Error,      /* 26 0x068 */
  &isr_CAN_B_MB,         /* 27 0x06C */
  &isr_CAN_B_MB14,       /* 28 0x070 */
  &isr_CAN_B_Error,      /* 29 0x074 */
  &isr_CAN_C_MB,         /* 30 0x078 */
  &isr_CAN_C_MB14,       /* 31 0x07C */
  &isr_CAN_C_Error,      /* 32 0x080 */
  &isr_CAN_D_MB,         /* 33 0x084 */
  &isr_CAN_D_MB14,       /* 34 0x088 */
  &isr_CAN_D_Error,      /* 35 0x08C */
  &isr_I2C,              /* 36 0x090 */
  &isr_DSPI_A,           /* 37 0x094 */
  &isr_DSPI_B,           /* 38 0x098 */
  &isr_eSCI_A,           /* 39 0x09C */
  &isr_eSCI_B,           /* 40 0x0A0 */
  &isr_eSCI_C,           /* 41 0x0A4 */
  &isr_eSCI_D,           /* 42 0x0A8 */
  &isr_eMIOS0,           /* 43 0x0AC */
  &isr_eMIOS1,           /* 44 0x0B0 */
  &isr_eMIOS2,           /* 45 0x0B4 */
  &isr_eMIOS3,           /* 46 0x0B8 */
  &isr_eMIOS4,           /* 47 0x0BC */
  &isr_eMIOS5,           /* 48 0x0C0 */
  &isr_eMIOS6,           /* 49 0x0C4 */
  &isr_eMIOS7,           /* 50 0x0C8 */
  &isr_eMIOS8,           /* 51 0x0CC */
  &isr_eMIOS9,           /* 52 0x0D0 */
  &isr_eMIOS10,          /* 53 0x0D4 */
  &isr_eMIOS11,          /* 54 0x0D8 */
  &isr_eMIOS12,          /* 55 0x0DC */
  &isr_eMIOS13,          /* 56 0x0E0 */
  &isr_eMIOS14,          /* 57 0x0E4 */
  &isr_eMIOS15,          /* 58 0x0E8 */
  &isr_ATD,              /* 59 0x0EC */
  &isr_CFM,              /* 60 0x0F0 */
  &isr_PIM,              /* 61 0x0F4 */
  &isr_IRQ,              /* 62 0x0F8 */
  &isr_XIRQ,             /* 63 0x0FC */
};

