/*  main.c

    a simple project to demonstrate the gdb stub and the MAC7111LCEVB
    sorts an array of numbers while blinking the LEDs and reporting
    the LED position out the ESCI_B serial port.

    -----

    Copyright (c) Freescale Semiconductor, Inc., 2004

    This file is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This file is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this file; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place, Suite 330
    Boston, MA  02111-1307  USA
*/

/*
$Id: $
*/

#define _MAIN_
#include "project.h"

int main ( void )
{
  unsigned short sort_array[SORTSIZE];

  for (;;)
  {
    _memcpy( (unsigned char *) &sort_array[0],
             (unsigned char *) &random_data[0],
             (SORTSIZE * sizeof(sort_array[0])));

    bubble_sort( sort_array, SORTSIZE );

    _memcpy( (unsigned char *) &sort_array[0],
             (unsigned char *) &random_data[0],
             (SORTSIZE * sizeof(sort_array[0])));

    shell_sort( sort_array, SORTSIZE );
  }

  return(0);
}
