/*
$Id: mac7111_crg.h,v 1.1 2004/04/26 16:45:56 ra4951 Exp $
*/

#ifndef _MAC7111_CRG_H_
#define _MAC7111_CRG_H_

#include "typedefs.h"

/* Clock and Reset Generator Definitions */
#define CRG_BASE 0xFC088000

#define CRG_SYNR   (*(volatile unsigned char *) 0xFC088000)
#define CRG_REFDV  (*(volatile unsigned char *) 0xFC088001)
#define CRG_CRGFLG (*(volatile unsigned char *) 0xFC088003)
#define CRG_CRGINT (*(volatile unsigned char *) 0xFC088004)
#define CRG_CLKSEL (*(volatile unsigned char *) 0xFC088005)
#define CRG_PLLCTL (*(volatile unsigned char *) 0xFC088006)
#define CRG_SDMCTL (*(volatile unsigned char *) 0xFC088007)
#define CRG_BDMCTL (*(volatile unsigned char *) 0xFC088008)

#define CRGFLG_STPEF   bit07_8
#define CRGFLG_PORF    bit06_8
#define CRGFLG_LVRF    bit05_8
#define CRGFLG_LOCKIF  bit04_8
#define CRGFLG_LOCK    bit03_8
#define CRGFLG_TRACK   bit02_8
#define CRGFLG_SCMIF   bit01_8
#define CRGFLG_SCM     bit00_8

#define CRGINT_LOCKIE  bit04_8
#define CRGINT_SCMIE   bit01_8

#define CLKSEL_PLLSEL  bit07_8
#define CLKSEL_PSTP    bit06_8
#define CLKSEL_PLLDOZE bit03_8
#define CLKSEL_RTIDOZE bit01_8
#define CLKSEL_SWTDOZE bit00_8

#define PLLCTL_CME     bit07_8
#define PLLCTL_PLLON   bit06_8
#define PLLCTL_AUTO    bit05_8
#define PLLCTL_ACQ     bit04_8
#define PLLCTL_FSTWKP  bit03_8
#define PLLCTL_PRE     bit02_8
#define PLLCTL_PWE     bit01_8
#define PLLCTL_SCME    bit00_8

#define SDMCTL_DOZE    bit01_8
#define SDMCTL_STOP    bit00_8

#define BDMCTL_RSBCK   bit06_8

#endif /* _MAC7111_CRG_H_ */
