/*
$Id: mac7111_esci.h,v 1.2 2004/04/27 14:16:49 ra4951 Exp $
*/

#ifndef _MAC7111_ESCI_H_
#define _MAC7111_ESCI_H_

#define ESCI_A_BASE         (0xFC0C4000)
#define ESCI_B_BASE         (0xFC0C8000)
#define ESCI_C_BASE         (0xFC0CC000)
#define ESCI_D_BASE         (0xFC0D0000)

#define ESCI_BD(addr)       (*(volatile unsigned short *) (addr + ESCI_BD_OFFSET))
#define ESCI_CR3(addr)      (*(volatile unsigned short *) (addr + ESCI_CR3_OFFSET))
#define ESCI_LINCTRL(addr)  (*(volatile unsigned short *) (addr + ESCI_LINCTRL_OFFSET))
#define ESCI_LINCRCP(addr)  (*(volatile unsigned short *) (addr + ESCI_LINCRCP_OFFSET))
#define ESCI_SR(addr)       (*(volatile unsigned short *) (addr + ESCI_SR_OFFSET))
#define ESCI_DRL(addr)      (*(volatile unsigned char  *) (addr + ESCI_DRL_OFFSET))
#define ESCI_CR12(addr)     (*(volatile unsigned short *) (addr + ESCI_CR12_OFFSET))

#define ESCI_BD_OFFSET      (0x0000)
#define ESCI_CR12_OFFSET    (0x0002)
#define ESCI_CR3_OFFSET     (0x0004)
#define ESCI_DRL_OFFSET     (0x0007)
#define ESCI_SR_OFFSET      (0x0008)
#define ESCI_LINSTAT_OFFSET (0x000A)
#define ESCI_LINCTRL_OFFSET (0x000C)
#define ESCI_LINRX_OFFSET   (0x0010)
#define ESCI_LINTX_OFFSET   (0x0014)
#define ESCI_LINCRCP_OFFSET (0x0018)

#define ESCI_CR12_LOOPS     (0x8000)
#define ESCI_CR12_SCISDOZ   (0x4000)
#define ESCI_CR12_RSRC      (0x2000)
#define ESCI_CR12_M         (0x1000)
#define ESCI_CR12_WAKE      (0x0800)
#define ESCI_CR12_ILT       (0x0400)
#define ESCI_CR12_PE        (0x0200)
#define ESCI_CR12_PT        (0x0100)
#define ESCI_CR12_TIE       (0x0080)
#define ESCI_CR12_TCIE      (0x0040)
#define ESCI_CR12_RIE       (0x0020)
#define ESCI_CR12_ILIE      (0x0010)
#define ESCI_CR12_TE        (0x0008)
#define ESCI_CR12_RE        (0x0004)
#define ESCI_CR12_RWU       (0x0002)
#define ESCI_CR12_SBK       (0x0001)

#define ESCI_CR3_MDIS       (0x80)
#define ESCI_CR3_FBR        (0x40)
#define ESCI_CR3_BSTP       (0x20)
#define ESCI_CR3_IEBERR     (0x10)
#define ESCI_CR3_RXDMA      (0x08)
#define ESCI_CR3_TXDMA      (0x04)
#define ESCI_CR3_BRK13      (0x02)
#define ESCI_CR3_TXDIR      (0x01)

#define ESCI_SR_TDRE        (0x8000)
#define ESCI_SR_TC          (0x4000)
#define ESCI_SR_RDRF        (0x2000)
#define ESCI_SR_IDLE        (0x1000)
#define ESCI_SR_OR          (0x0800)
#define ESCI_SR_NF          (0x0400)
#define ESCI_SR_FE          (0x0200)
#define ESCI_SR_PF          (0x0100)
#define ESCI_SR_BERR        (0x0010)
#define ESCI_SR_RAF         (0x0001)

#endif /* MAC7111_ESCI_H_*/
