/*
$Id: mac7111_pim.h,v 1.1 2004/04/26 16:45:56 ra4951 Exp $
*/

#ifndef _MAC7111_PIM_H_
#define _MAC7111_PIM_H_

/* Port Integration Module Definitions */
#define PIM_BASE     (0xFC0E8000)
#define PORTA_OFFSET (0x0000)
#define PORTB_OFFSET (0x0040)
#define PORTC_OFFSET (0x0080)
#define PORTD_OFFSET (0x00C0)
#define PORTE_OFFSET (0x0100)
#define PORTF_OFFSET (0x0140)
#define PORTG_OFFSET (0x0180)
#define PORTH_OFFSET (0x01C0)

#define PORTA_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTA_OFFSET + (2 * pin)))
#define PORTB_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTB_OFFSET + (2 * pin)))
#define PORTC_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTC_OFFSET + (2 * pin)))
#define PORTD_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTD_OFFSET + (2 * pin)))
#define PORTE_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTE_OFFSET + (2 * pin)))
#define PORTF_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTF_OFFSET + (2 * pin)))
#define PORTG_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTG_OFFSET + (2 * pin)))
#define PORTH_CONFIG(pin) (*(volatile unsigned short *) (PIM_BASE + PORTH_OFFSET + (2 * pin)))

#define GPIO_MODE         (0)
#define DDR_OUTPUT        (0x0040)
#define DDR_INPUT         (0)
#define PERIPHERIAL_MODE  (0x0080)

#define PORTIFR_OFFSET    (0x0020)
#define PORTDATA_OFFSET   (0x0024)
#define PORTIR_OFFSET     (0x0026)
#define PINDATA_OFFSET    (0x0028)

#define PORTA_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTA_OFFSET + PORTDATA_OFFSET))
#define PORTB_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTB_OFFSET + PORTDATA_OFFSET))
#define PORTC_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTC_OFFSET + PORTDATA_OFFSET))
#define PORTD_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTD_OFFSET + PORTDATA_OFFSET))
#define PORTE_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTE_OFFSET + PORTDATA_OFFSET))
#define PORTF_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTF_OFFSET + PORTDATA_OFFSET))
#define PORTG_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTG_OFFSET + PORTDATA_OFFSET))
#define PORTH_PORTDATA    (*(volatile unsigned short *) (PIM_BASE + PORTH_OFFSET + PORTDATA_OFFSET))

#define PORTA_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTA_OFFSET + PINDATA_OFFSET + pin))
#define PORTB_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTB_OFFSET + PINDATA_OFFSET + pin))
#define PORTC_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTC_OFFSET + PINDATA_OFFSET + pin))
#define PORTD_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTD_OFFSET + PINDATA_OFFSET + pin))
#define PORTE_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTE_OFFSET + PINDATA_OFFSET + pin))
#define PORTF_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTF_OFFSET + PINDATA_OFFSET + pin))
#define PORTG_PINDATA(pin)  (*(volatile unsigned char *) (PIM_BASE + PORTG_OFFSET + PINDATA_OFFSET + pin))


#endif /* _MAC7111_PIM_H_ */
