/*
$Id: mac7111_pit.h,v 1.2 2004/04/27 14:17:57 ra4951 Exp $
*/

#ifndef _MAC7111_PIT_H_
#define _MAC7111_PIT_H_

/* Periodic Interrupt Timer Module Definitions */

#define PIT_BASE         (0xFC08C000)
#define TLVAL0_OFFSET    (0x0000)
#define TVAL0_OFFSET     (0x0080)

#define PIT_TLVAL(chan)  (*(volatile unsigned int *) (PIT_BASE + TLVAL0_OFFSET + (4 * chan)))
#define PIT_TVAL(chan)   (*(volatile unsigned int *) (PIT_BASE + TVAL0_OFFSET + (4 * chan)))

#define PITFLG_OFFSET         (0x0100)
#define PITINTEN_OFFSET       (0x0104)
#define PITINTSEL_OFFSET      (0x0108)
#define PITEN_OFFSET          (0x010C)
#define PITCTRL_OFFSET        (0x0110)

#define PIT_FLAG_RTIF         (0x00000001)
#define PIT_FLAG_TIF(chan)    (0x00000001 << chan)
#define PIT_INTSEL_ISEL(chan) (0x00000001 << chan)
#define PIT_INTEN_RTIE        (0x00000001)
#define PIT_INTEN_TIE(chan)   (0x00000001 << chan)

#define PIT_EN_RTIEN          (0x00000001)
#define PIT_EN_PEN(chan)      (0x00000001 << chan)

#define PIT_FLG    (*(volatile unsigned int *) (PIT_BASE + PITFLG_OFFSET))
#define PIT_INTEN  (*(volatile unsigned int *) (PIT_BASE + PITINTEN_OFFSET))
#define PIT_INTSEL (*(volatile unsigned int *) (PIT_BASE + PITINTSEL_OFFSET))
#define PIT_EN     (*(volatile unsigned int *) (PIT_BASE + PITEN_OFFSET))
#define PIT_CTRL   (*(volatile unsigned int *) (PIT_BASE + PITCTRL_OFFSET))

#endif /* _MAC7111_PIT_H_ */
