/* typedefs.h

   integer type definitions

   -----

   Copyright (c) Freescale Semiconductor, Inc., 2004

   This file is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This file is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this file; if not, write to:

   Free Software Foundation, Inc.
   59 Temple Place, Suite 330
   Boston, MA  02111-1307  USA

*/

/*
$Id: $
*/

#ifndef _TYPEDEFS_H_
#define _TYPEDEFS_H_

/*************************************************************************/
/*  general data types                                                   */
/*************************************************************************/

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE (!FALSE)
#endif

typedef unsigned char BOOL;

typedef signed char INT8;
typedef unsigned char UINT8;
typedef volatile signed char VINT8;
typedef volatile unsigned char VUINT8;

typedef signed short INT16;
typedef unsigned short UINT16;
typedef volatile signed short VINT16;
typedef volatile unsigned short VUINT16;

typedef signed long INT32;
typedef unsigned long UINT32;
typedef volatile signed long VINT32;
typedef volatile unsigned long VUINT32;

typedef signed long long INT64;
typedef unsigned long long UINT64;
typedef volatile signed long long VINT64;
typedef volatile unsigned long long VUINT64;

typedef unsigned char bool_t;
typedef unsigned char Bool_t;

typedef signed char int8_t;
typedef unsigned char uint8_t;
typedef volatile signed char vint8_t;
typedef volatile unsigned char vuint8_t;

typedef signed short int16_t;
typedef unsigned short uint16_t;
typedef volatile signed short vint16_t;
typedef volatile unsigned short vuint16_t;

typedef signed long int32_t;
typedef unsigned long uint32_t;
typedef volatile signed long vint32_t;
typedef volatile unsigned long vuint32_t;

typedef signed long long int64_t;
typedef unsigned long long uint64_t;
typedef volatile signed long long vint64_t;
typedef volatile unsigned long long vuint64_t;

/* Bit names for general use */
#define bit31_32 0x80000000
#define bit30_32 0x40000000
#define bit29_32 0x20000000
#define bit28_32 0x10000000
#define bit27_32 0x08000000
#define bit26_32 0x04000000
#define bit25_32 0x02000000
#define bit24_32 0x01000000
#define bit23_32 0x00800000
#define bit22_32 0x00400000
#define bit21_32 0x00200000
#define bit20_32 0x00100000
#define bit19_32 0x00080000
#define bit18_32 0x00040000
#define bit17_32 0x00020000
#define bit16_32 0x00010000
#define bit15_32 0x00008000
#define bit14_32 0x00004000
#define bit13_32 0x00002000
#define bit12_32 0x00001000
#define bit11_32 0x00000800
#define bit10_32 0x00000400
#define bit09_32 0x00000200
#define bit08_32 0x00000100
#define bit07_32 0x00000080
#define bit06_32 0x00000040
#define bit05_32 0x00000020
#define bit04_32 0x00000010
#define bit03_32 0x00000008
#define bit02_32 0x00000004
#define bit01_32 0x00000002
#define bit00_32 0x00000001

#define bit31 bit31_32 
#define bit30 bit30_32 
#define bit29 bit29_32 
#define bit28 bit28_32 
#define bit27 bit27_32 
#define bit26 bit26_32 
#define bit25 bit25_32 
#define bit24 bit24_32 
#define bit23 bit23_32 
#define bit22 bit22_32 
#define bit21 bit21_32 
#define bit20 bit20_32 
#define bit19 bit19_32 
#define bit18 bit18_32 
#define bit17 bit17_32 
#define bit16 bit16_32 
#define bit15 bit15_32 
#define bit14 bit14_32 
#define bit13 bit13_32 
#define bit12 bit12_32 
#define bit11 bit11_32 
#define bit10 bit10_32 
#define bit09 bit09_32 
#define bit08 bit08_32 
#define bit07 bit07_32 
#define bit06 bit06_32 
#define bit05 bit05_32 
#define bit04 bit04_32 
#define bit03 bit03_32 
#define bit02 bit02_32 
#define bit01 bit01_32 
#define bit00 bit00_32 

#define bit15_16 0x8000
#define bit14_16 0x4000
#define bit13_16 0x2000
#define bit12_16 0x1000
#define bit11_16 0x0800
#define bit10_16 0x0400
#define bit09_16 0x0200
#define bit08_16 0x0100
#define bit07_16 0x0080
#define bit06_16 0x0040
#define bit05_16 0x0020
#define bit04_16 0x0010
#define bit03_16 0x0008
#define bit02_16 0x0004
#define bit01_16 0x0002
#define bit00_16 0x0001

#define bit07_8 0x80
#define bit06_8 0x40
#define bit05_8 0x20
#define bit04_8 0x10
#define bit03_8 0x08
#define bit02_8 0x04
#define bit01_8 0x02
#define bit00_8 0x01

#endif  //_TYPEDEFS_H_
